<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Map extends Controller_Handler {
		
        public function before() {
            $this->model = new Model_Teacher_Map;
            $this->setAccessLevel(self::ACCESS_TEACHER);
            parent::before();
        }
        
        public function action_AddMap() {
			
			$json = $this->post->offsetGet('data');
			$json = json_decode($json, true);

			for ($i = 0; $i < $json['modulesCount']; $i++) {
				$query = $this->model->addModule(
					$this->user['TeacherID'],
					$json['DisciplineID'],
					$i + 1,
					$json[$i]['moduleName']
				);
				$ModuleID = $query[0]['Num'];
				
				for ($j = 0; $j < $json[$i]['subModules']['subModulesCount']; $j++) {
					$this->model->addSubmodule(
							$this->user['TeacherID'], 
							$ModuleID,
							$json[$i]['subModules'][$j]['maxRate'],
							$j + 1,
							$json[$i]['subModules'][$j]['subModuleName'],
							'description',
							$json[$i]['subModules'][$j]['typeControl']
					);
				}
			
			}
		}
		
		public function action_ChangeModuleName() {
            $this->post -> rule('ModuleID', 'not_empty')
                        -> rule('ModuleID', 'digit')
						-> rule('ModuleName', 'not_empty');
            if($this->post->check()) {
                $this->model->ChangeModuleName($this->user['TeacherID'], $this->post->offsetGet('ModuleID'), $this->post->offsetGet('ModuleName'));
				$this->response->body(json_encode('Ok, ChangeModuleName!'));
            }
            else
                $this->response->body(json_encode('Error, ChangeModuleName'));
		}

		public function action_ChangeModuleOrder() {
			
		}
		
		public function action_DeleteModule() {
            $this->post -> rule('ModuleID', 'not_empty')
                        -> rule('ModuleID', 'digit');
            if($this->post->check()) {
                $result = $this->model->deleteModule($this->user['TeacherID'], $this->post->offsetGet('ModuleID'));
				if ($result[0]['Num'] == '-1')
					$this->response->body(json_encode('Error, score was set!'));
				else
					$this->response->body(json_encode('Ok, deleteModule!'));
            }
            else
                $this->response->body(json_encode('Error, deleteModule'));
        }
		
		public function action_ChangeSubmoduleName() {
            $this->post -> rule('SubmoduleID', 'not_empty')
                        -> rule('SubmoduleID', 'digit')
						-> rule('SubmoduleName', 'not_empty');
            if($this->post->check()) {
                $this->model->ChangeSubmoduleName($this->user['TeacherID'], $this->post->offsetGet('SubmoduleID'), $this->post->offsetGet('SubmoduleName'));
				$this->response->body(json_encode('Ok, ChangeSubmoduleName!'));
            }
            else
                $this->response->body(json_encode('Error, ChangeSubmoduleName'));
		}
		
		public function action_ChangeSubmoduleOrder() {
			
		}
		
		public function action_ChangeSubmoduleMaxRate() {
            $this->post -> rule('SubmoduleID', 'not_empty')
                        -> rule('SubmoduleID', 'digit')
						-> rule('MaxRate', 'not_empty');
            if($this->post->check()) {
                //$this->model->ChangeSubmoduleMaxRate($this->user['TeacherID'], $this->post->offsetGet('SubmoduleID'), $this->post->offsetGet('MaxRate'));
				$this->response->body(json_encode('Ok, ChangeSubmoduleMaxRate!'));
            }
            else
                $this->response->body(json_encode('Error, ChangeSubmoduleMaxRate'));
		}
		
		public function action_ChangeSubmoduleDescription() {
            $this->post -> rule('SubmoduleID', 'not_empty')
                        -> rule('SubmoduleID', 'digit')
						-> rule('Description', 'not_empty');
            if($this->post->check()) {
                //$this->model->ChangeSubmoduleDescription($this->user['TeacherID'], $this->post->offsetGet('SubmoduleID'), $this->post->offsetGet('Description'));
				$this->response->body(json_encode('Ok, ChangeSubmoduleDescription!'));
            }
            else
                $this->response->body(json_encode('Error, ChangeSubmoduleDescription'));
		}
		
		public function action_DeleteSubmodule() {
            $this->post -> rule('SubModuleID', 'not_empty')
                        -> rule('SubModuleID', 'digit');
            if($this->post->check()) {
                $result = $this->model->deleteSubmodule($this->user['TeacherID'], $this->post->offsetGet('SubModuleID'));
				if ($result[0]['Num'] == '-1')
					$this->response->body(json_encode('Error, score was set!'));
				else	
					$this->response->body(json_encode('Ok, deleteSubModule!'));
            }
            else
                $this->response->body(json_encode('Error, deleteSubModule'));
        }
}
